#!/usr/bin/env python
# -*- coding: UTF8 -*-

# Vorbis radio grabber
# Copyright (c) 2008, Jean-François Fortin Tam

#This program is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 3 of the License, or
#(at your option) any later version.

#This program is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.

#You should have received a copy of the GNU General Public License
#along with this program.  If not, see <http://www.gnu.org/licenses/>.

import os
from urllib import urlopen
try:
    from BeautifulSoup import BeautifulSoup
except:
    print "python-beautifulsoup is missing, install it"
    exit(0)
import string

MAIN_URL="http://dir.xiph.org/by_format/Ogg_Vorbis"
AMOUNT_OF_RADIOS=100
OUTPUT=os.path.join(os.getcwd(), "iradio-initial.pls")

#calculate how many pages we will need to parse at 20 radios per page
AMOUNT_OF_PAGES = 5#AMOUNT_OF_RADIOS / 20 #nevermind, seems like the website can display no more than 5 pages
print "Currently set to fetch", AMOUNT_OF_RADIOS, "radios. Commencing operation."

radios=[]
radio_links=[]
radio_names=[]
radio_genres=[]#only the first genre tag

pages_contents=[]
current_page=0 #those geeks at xiph start at 0
while current_page is not AMOUNT_OF_PAGES:
    url= "http://dir.xiph.org/by_format/Ogg_Vorbis?page="+str(current_page)
    html = urlopen(url).read()
    pages_contents.append(html)
    print "\tPage", current_page, "saved."
    current_page+=1

current_page=0 #those geeks at xiph start at 0
while current_page is not AMOUNT_OF_PAGES:
    soup = BeautifulSoup(pages_contents[current_page])

    #find the playlist urls
    foo = soup.findAll("td", { "class" : "tune-in" })
    for radio in foo:
        first_playlist=radio.p.nextSibling.nextSibling.a["href"]#we don't want the first p tag, so nextSibling
        radio_links.append( "http://dir.xiph.org"+first_playlist )

    #find the names
    foo = soup.findAll("span", { "class" : "name" })
    for radio in foo:
        try:radio_names.append(radio.a.contents[0])
        except:radio_names.append(radio.contents[0]) #in case the radio name is not in a link

    #find the genres
    foo = soup.findAll("ul", { "class" : "inline-tags" })
    for radio in foo:
        try:
            first_genre_tag=radio.li.a.contents[0]
            if "\n" in first_genre_tag: first_genre_tag=first_genre_tag.splitlines()[0]#I only care about the first genre tag
            radio_genres.append(first_genre_tag)
        except:
            radio_genres.append("Unknown") #in case no genre was specified



    print "\tPage", current_page, "parsed."
    current_page+=1

print "Done parsing.\nMerging results..."
print len(radio_names),"names", len(radio_links),"links", len(radio_genres),"genres"
position = 0
for i in radio_names:
    radios.append( [i] ) #don't forget the []'s for the first list
    position+=1

position = 0
for i in radio_links:
    radios[position].append(i)
    position+=1

position = 0
for i in radio_genres:
    radios[position].append(i)
    position+=1

#write a rhythmbox initial playlist
big_ass_table="""[playlist]

"""
position=1
for radio in radios:
    big_ass_table+="file"+str(position)+"="+radio[1]+"\n"
    big_ass_table+="title"+str(position)+"="+radio[0]+"\n"
    big_ass_table+="genre"+str(position)+"="+radio[2]+"\n\n"
    position+=1
    
f = open(OUTPUT, "w")
f.write(big_ass_table)
f.close()
print "Done!", len(radios), "OGG Vorbis radio stations were written to"
print "\t",OUTPUT
